import apiClient from '../apiClient';
import type { DistribuidorDto } from '../../models/dtos/Distribucion/DistribuidorDto';
import type { CreateDistribuidorDto } from '../../models/dtos/Distribucion/CreateDistribuidorDto';
import type { UpdateDistribuidorDto } from '../../models/dtos/Distribucion/UpdateDistribuidorDto';
import type { DistribuidorDropdownDto } from '../../models/dtos/Distribucion/DistribuidorDropdownDto';
import type { DistribuidorLookupDto } from '../../models/dtos/Distribucion/DistribuidorLookupDto';

const getAllDistribuidores = async (nombreFilter?: string, nroDocFilter?: string, soloActivos: boolean = true): Promise<DistribuidorDto[]> => {
    const params: Record<string, string | boolean> = {
        soloActivos: soloActivos
    };
    if (nombreFilter) params.nombre = nombreFilter;
    if (nroDocFilter) params.nroDoc = nroDocFilter;

    const response = await apiClient.get<DistribuidorDto[]>('/distribuidores', { params });
    return response.data;
};

const getDistribuidorById = async (id: number): Promise<DistribuidorDto> => {
    const response = await apiClient.get<DistribuidorDto>(`/distribuidores/${id}`);
    return response.data;
};

const getDistribuidorLookupById = async (id: number): Promise<DistribuidorLookupDto> => {
    const response = await apiClient.get<DistribuidorLookupDto>(`/distribuidores/${id}/lookup`);
    return response.data;
};

const createDistribuidor = async (data: CreateDistribuidorDto): Promise<DistribuidorDto> => {
    const response = await apiClient.post<DistribuidorDto>('/distribuidores', data);
    return response.data;
};

const updateDistribuidor = async (id: number, data: UpdateDistribuidorDto): Promise<void> => {
    await apiClient.put(`/distribuidores/${id}`, data);
};

const deleteDistribuidor = async (id: number): Promise<void> => {
    await apiClient.delete(`/distribuidores/${id}`);
};

const getAllDistribuidoresDropdown = async (soloActivos: boolean = true): Promise<DistribuidorDropdownDto[]> => {
    const response = await apiClient.get<DistribuidorDropdownDto[]>('/distribuidores/dropdown', { params: { soloActivos } });
    return response.data;
};

const toggleBajaDistribuidor = async (id: number, data: { darDeBaja: boolean, fechaBaja: string | null }): Promise<void> => {
    await apiClient.put(`/distribuidores/${id}/toggle-baja`, data);
};

const distribuidorService = {
    getAllDistribuidores,
    getDistribuidorById,
    createDistribuidor,
    updateDistribuidor,
    deleteDistribuidor,
    getAllDistribuidoresDropdown,
    getDistribuidorLookupById,
    toggleBajaDistribuidor,
};

export default distribuidorService;